diff --git a/target-mips/translate.c b/target-mips/translate.c
index cefccb0..590c2b6 100644
--- a/target-mips/translate.c
+++ b/target-mips/translate.c
@@ -3887,14 +3843,14 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
         case 2:
         case 4:
         case 6:
-            tcg_gen_helper_0_1(do_mtc0_taglo, t0);
+            gen_helper_mtc0_taglo(t0);
             rn = "TagLo";
             break;
         case 1:
         case 3:
         case 5:
         case 7:
-            tcg_gen_helper_0_1(do_mtc0_datalo, t0);
+            gen_helper_mtc0_datalo(t0);
             rn = "DataLo";
             break;
         default:
@@ -3907,14 +3863,14 @@ static void gen_mtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int se
         case 2:
         case 4:
         case 6:
-            tcg_gen_helper_0_1(do_mtc0_taghi, t0);
+            gen_helper_mtc0_taghi(t0);
             rn = "TagHi";
             break;
         case 1:
         case 3:
         case 5:
         case 7:
-            tcg_gen_helper_0_1(do_mtc0_datahi, t0);
+            gen_helper_mtc0_datahi(t0);
             rn = "DataHi";
             break;
         default:
@@ -3988,17 +3944,17 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_mvpcontrol, t0);
+            gen_helper_mfc0_mvpcontrol(t0);
             rn = "MVPControl";
             break;
         case 2:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_mvpconf0, t0);
+            gen_helper_mfc0_mvpconf0(t0);
             rn = "MVPConf0";
             break;
         case 3:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_mvpconf1, t0);
+            gen_helper_mfc0_mvpconf1(t0);
             rn = "MVPConf1";
             break;
         default:
@@ -4008,7 +3964,7 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 1:
         switch (sel) {
         case 0:
-            tcg_gen_helper_1_0(do_mfc0_random, t0);
+            gen_helper_mfc0_random(t0);
             rn = "Random";
             break;
         case 1:
@@ -4058,37 +4014,37 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_tcstatus, t0);
+            gen_helper_mfc0_tcstatus(t0);
             rn = "TCStatus";
             break;
         case 2:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_mfc0_tcbind, t0);
+            gen_helper_mfc0_tcbind(t0);
             rn = "TCBind";
             break;
         case 3:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_dmfc0_tcrestart, t0);
+            gen_helper_dmfc0_tcrestart(t0);
             rn = "TCRestart";
             break;
         case 4:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_dmfc0_tchalt, t0);
+            gen_helper_dmfc0_tchalt(t0);
             rn = "TCHalt";
             break;
         case 5:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_dmfc0_tccontext, t0);
+            gen_helper_dmfc0_tccontext(t0);
             rn = "TCContext";
             break;
         case 6:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_dmfc0_tcschedule, t0);
+            gen_helper_dmfc0_tcschedule(t0);
             rn = "TCSchedule";
             break;
         case 7:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_1_0(do_dmfc0_tcschefback, t0);
+            gen_helper_dmfc0_tcschefback(t0);
             rn = "TCScheFBack";
             break;
         default:
@@ -4112,7 +4068,7 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             rn = "Context";
             break;
         case 1:
-//            tcg_gen_helper_1_0(do_dmfc0_contextconfig, t0); /* SmartMIPS ASE */
+//            gen_helper_dmfc0_contextconfig(t0); /* SmartMIPS ASE */
             rn = "ContextConfig";
 //            break;
         default:
@@ -4196,7 +4152,7 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             /* Mark as an IO operation because we read the time.  */
             if (use_icount)
                 gen_io_start();
-            tcg_gen_helper_1_0(do_mfc0_count, t0);
+            gen_helper_mfc0_count(t0);
             if (use_icount) {
                 gen_io_end();
                 ctx->bstate = BS_STOP;
@@ -4323,7 +4279,7 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 17:
         switch (sel) {
         case 0:
-            tcg_gen_helper_1_0(do_dmfc0_lladdr, t0);
+            gen_helper_dmfc0_lladdr(t0);
             rn = "LLAddr";
             break;
         default:
@@ -4333,7 +4289,7 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 18:
         switch (sel) {
         case 0 ... 7:
-            tcg_gen_helper_1_i(do_dmfc0_watchlo, t0, sel);
+            gen_helper_1i(dmfc0_watchlo, t0, sel);
             rn = "WatchLo";
             break;
         default:
@@ -4343,7 +4299,7 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 19:
         switch (sel) {
         case 0 ... 7:
-            tcg_gen_helper_1_i(do_mfc0_watchhi, t0, sel);
+            gen_helper_1i(mfc0_watchhi, t0, sel);
             rn = "WatchHi";
             break;
         default:
@@ -4379,23 +4335,23 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 23:
         switch (sel) {
         case 0:
-            tcg_gen_helper_1_0(do_mfc0_debug, t0); /* EJTAG support */
+            gen_helper_mfc0_debug(t0); /* EJTAG support */
             rn = "Debug";
             break;
         case 1:
-//            tcg_gen_helper_1_0(do_dmfc0_tracecontrol, t0); /* PDtrace support */
+//            gen_helper_dmfc0_tracecontrol(t0); /* PDtrace support */
             rn = "TraceControl";
 //            break;
         case 2:
-//            tcg_gen_helper_1_0(do_dmfc0_tracecontrol2, t0); /* PDtrace support */
+//            gen_helper_dmfc0_tracecontrol2(t0); /* PDtrace support */
             rn = "TraceControl2";
 //            break;
         case 3:
-//            tcg_gen_helper_1_0(do_dmfc0_usertracedata, t0); /* PDtrace support */
+//            gen_helper_dmfc0_usertracedata(t0); /* PDtrace support */
             rn = "UserTraceData";
 //            break;
         case 4:
-//            tcg_gen_helper_1_0(do_dmfc0_tracebpc, t0); /* PDtrace support */
+//            gen_helper_dmfc0_tracebpc(t0); /* PDtrace support */
             rn = "TraceBPC";
 //            break;
         default:
@@ -4420,31 +4376,31 @@ static void gen_dmfc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             rn = "Performance0";
             break;
         case 1:
-//            tcg_gen_helper_1_0(do_dmfc0_performance1, t0);
+//            gen_helper_dmfc0_performance1(t0);
             rn = "Performance1";
 //            break;
         case 2:
-//            tcg_gen_helper_1_0(do_dmfc0_performance2, t0);
+//            gen_helper_dmfc0_performance2(t0);
             rn = "Performance2";
 //            break;
         case 3:
-//            tcg_gen_helper_1_0(do_dmfc0_performance3, t0);
+//            gen_helper_dmfc0_performance3(t0);
             rn = "Performance3";
 //            break;
         case 4:
-//            tcg_gen_helper_1_0(do_dmfc0_performance4, t0);
+//            gen_helper_dmfc0_performance4(t0);
             rn = "Performance4";
 //            break;
         case 5:
-//            tcg_gen_helper_1_0(do_dmfc0_performance5, t0);
+//            gen_helper_dmfc0_performance5(t0);
             rn = "Performance5";
 //            break;
         case 6:
-//            tcg_gen_helper_1_0(do_dmfc0_performance6, t0);
+//            gen_helper_dmfc0_performance6(t0);
             rn = "Performance6";
 //            break;
         case 7:
-//            tcg_gen_helper_1_0(do_dmfc0_performance7, t0);
+//            gen_helper_dmfc0_performance7(t0);
             rn = "Performance7";
 //            break;
         default:
@@ -4562,12 +4518,12 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 0:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_index, t0);
+            gen_helper_mtc0_index(t0);
             rn = "Index";
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_mvpcontrol, t0);
+            gen_helper_mtc0_mvpcontrol(t0);
             rn = "MVPControl";
             break;
         case 2:
@@ -4592,22 +4548,22 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_vpecontrol, t0);
+            gen_helper_mtc0_vpecontrol(t0);
             rn = "VPEControl";
             break;
         case 2:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_vpeconf0, t0);
+            gen_helper_mtc0_vpeconf0(t0);
             rn = "VPEConf0";
             break;
         case 3:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_vpeconf1, t0);
+            gen_helper_mtc0_vpeconf1(t0);
             rn = "VPEConf1";
             break;
         case 4:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_yqmask, t0);
+            gen_helper_mtc0_yqmask(t0);
             rn = "YQMask";
             break;
         case 5:
@@ -4622,7 +4578,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             break;
         case 7:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_vpeopt, t0);
+            gen_helper_mtc0_vpeopt(t0);
             rn = "VPEOpt";
             break;
         default:
@@ -4632,42 +4588,42 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 2:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_entrylo0, t0);
+            gen_helper_mtc0_entrylo0(t0);
             rn = "EntryLo0";
             break;
         case 1:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcstatus, t0);
+            gen_helper_mtc0_tcstatus(t0);
             rn = "TCStatus";
             break;
         case 2:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcbind, t0);
+            gen_helper_mtc0_tcbind(t0);
             rn = "TCBind";
             break;
         case 3:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcrestart, t0);
+            gen_helper_mtc0_tcrestart(t0);
             rn = "TCRestart";
             break;
         case 4:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tchalt, t0);
+            gen_helper_mtc0_tchalt(t0);
             rn = "TCHalt";
             break;
         case 5:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tccontext, t0);
+            gen_helper_mtc0_tccontext(t0);
             rn = "TCContext";
             break;
         case 6:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcschedule, t0);
+            gen_helper_mtc0_tcschedule(t0);
             rn = "TCSchedule";
             break;
         case 7:
             check_insn(env, ctx, ASE_MT);
-            tcg_gen_helper_0_1(do_mtc0_tcschefback, t0);
+            gen_helper_mtc0_tcschefback(t0);
             rn = "TCScheFBack";
             break;
         default:
@@ -4677,7 +4633,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 3:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_entrylo1, t0);
+            gen_helper_mtc0_entrylo1(t0);
             rn = "EntryLo1";
             break;
         default:
@@ -4687,11 +4643,11 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 4:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_context, t0);
+            gen_helper_mtc0_context(t0);
             rn = "Context";
             break;
         case 1:
-//           tcg_gen_helper_0_1(do_mtc0_contextconfig, t0); /* SmartMIPS ASE */
+//           gen_helper_mtc0_contextconfig(t0); /* SmartMIPS ASE */
             rn = "ContextConfig";
 //           break;
         default:
@@ -4701,12 +4657,12 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 5:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_pagemask, t0);
+            gen_helper_mtc0_pagemask(t0);
             rn = "PageMask";
             break;
         case 1:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_pagegrain, t0);
+            gen_helper_mtc0_pagegrain(t0);
             rn = "PageGrain";
             break;
         default:
@@ -4716,32 +4672,32 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 6:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_wired, t0);
+            gen_helper_mtc0_wired(t0);
             rn = "Wired";
             break;
         case 1:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf0, t0);
+            gen_helper_mtc0_srsconf0(t0);
             rn = "SRSConf0";
             break;
         case 2:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf1, t0);
+            gen_helper_mtc0_srsconf1(t0);
             rn = "SRSConf1";
             break;
         case 3:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf2, t0);
+            gen_helper_mtc0_srsconf2(t0);
             rn = "SRSConf2";
             break;
         case 4:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf3, t0);
+            gen_helper_mtc0_srsconf3(t0);
             rn = "SRSConf3";
             break;
         case 5:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsconf4, t0);
+            gen_helper_mtc0_srsconf4(t0);
             rn = "SRSConf4";
             break;
         default:
@@ -4752,7 +4708,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
         switch (sel) {
         case 0:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_hwrena, t0);
+            gen_helper_mtc0_hwrena(t0);
             rn = "HWREna";
             break;
         default:
@@ -4766,7 +4722,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 9:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_count, t0);
+            gen_helper_mtc0_count(t0);
             rn = "Count";
             break;
         /* 6,7 are implementation dependent */
@@ -4779,7 +4735,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 10:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_entryhi, t0);
+            gen_helper_mtc0_entryhi(t0);
             rn = "EntryHi";
             break;
         default:
@@ -4789,7 +4745,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 11:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_compare, t0);
+            gen_helper_mtc0_compare(t0);
             rn = "Compare";
             break;
         /* 6,7 are implementation dependent */
@@ -4802,7 +4758,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 12:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_status, t0);
+            gen_helper_mtc0_status(t0);
             /* BS_STOP isn't good enough here, hflags may have changed. */
             gen_save_pc(ctx->pc + 4);
             ctx->bstate = BS_EXCP;
@@ -4810,14 +4766,14 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             break;
         case 1:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_intctl, t0);
+            gen_helper_mtc0_intctl(t0);
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
             rn = "IntCtl";
             break;
         case 2:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_srsctl, t0);
+            gen_helper_mtc0_srsctl(t0);
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
             rn = "SRSCtl";
@@ -4836,7 +4792,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 13:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_cause, t0);
+            gen_helper_mtc0_cause(t0);
             rn = "Cause";
             break;
         default:
@@ -4863,7 +4819,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             break;
         case 1:
             check_insn(env, ctx, ISA_MIPS32R2);
-            tcg_gen_helper_0_1(do_mtc0_ebase, t0);
+            gen_helper_mtc0_ebase(t0);
             rn = "EBase";
             break;
         default:
@@ -4873,7 +4829,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 16:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_config0, t0);
+            gen_helper_mtc0_config0(t0);
             rn = "Config";
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
@@ -4883,7 +4839,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
             rn = "Config1";
             break;
         case 2:
-            tcg_gen_helper_0_1(do_mtc0_config2, t0);
+            gen_helper_mtc0_config2(t0);
             rn = "Config2";
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
@@ -4911,7 +4867,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 18:
         switch (sel) {
         case 0 ... 7:
-            tcg_gen_helper_0_1i(do_mtc0_watchlo, t0, sel);
+            gen_helper_1i(mtc0_watchlo, t0, sel);
             rn = "WatchLo";
             break;
         default:
@@ -4921,7 +4877,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 19:
         switch (sel) {
         case 0 ... 7:
-            tcg_gen_helper_0_1i(do_mtc0_watchhi, t0, sel);
+            gen_helper_1i(mtc0_watchhi, t0, sel);
             rn = "WatchHi";
             break;
         default:
@@ -4932,7 +4888,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
         switch (sel) {
         case 0:
             check_insn(env, ctx, ISA_MIPS3);
-            tcg_gen_helper_0_1(do_mtc0_xcontext, t0);
+            gen_helper_mtc0_xcontext(t0);
             rn = "XContext";
             break;
         default:
@@ -4943,7 +4899,7 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
        /* Officially reserved, but sel 0 is used for R1x000 framemask */
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_framemask, t0);
+            gen_helper_mtc0_framemask(t0);
             rn = "Framemask";
             break;
         default:
@@ -4957,32 +4913,32 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 23:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_debug, t0); /* EJTAG support */
+            gen_helper_mtc0_debug(t0); /* EJTAG support */
             /* BS_STOP isn't good enough here, hflags may have changed. */
             gen_save_pc(ctx->pc + 4);
             ctx->bstate = BS_EXCP;
             rn = "Debug";
             break;
         case 1:
-//            tcg_gen_helper_0_1(do_mtc0_tracecontrol, t0); /* PDtrace support */
+//            gen_helper_mtc0_tracecontrol(t0); /* PDtrace support */
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
             rn = "TraceControl";
 //            break;
         case 2:
-//            tcg_gen_helper_0_1(do_mtc0_tracecontrol2, t0); /* PDtrace support */
+//            gen_helper_mtc0_tracecontrol2(t0); /* PDtrace support */
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
             rn = "TraceControl2";
 //            break;
         case 3:
-//            tcg_gen_helper_0_1(do_mtc0_usertracedata, t0); /* PDtrace support */
+//            gen_helper_mtc0_usertracedata(t0); /* PDtrace support */
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
             rn = "UserTraceData";
 //            break;
         case 4:
-//            tcg_gen_helper_0_1(do_mtc0_tracebpc, t0); /* PDtrace support */
+//            gen_helper_mtc0_tracebpc(t0); /* PDtrace support */
             /* Stop translation as we may have switched the execution mode */
             ctx->bstate = BS_STOP;
             rn = "TraceBPC";
@@ -5005,35 +4961,35 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
     case 25:
         switch (sel) {
         case 0:
-            tcg_gen_helper_0_1(do_mtc0_performance0, t0);
+            gen_helper_mtc0_performance0(t0);
             rn = "Performance0";
             break;
         case 1:
-//            tcg_gen_helper_0_1(do_mtc0_performance1, t0);
+//            gen_helper_mtc0_performance1(t0);
             rn = "Performance1";
 //            break;
         case 2:
-//            tcg_gen_helper_0_1(do_mtc0_performance2, t0);
+//            gen_helper_mtc0_performance2(t0);
             rn = "Performance2";
 //            break;
         case 3:
-//            tcg_gen_helper_0_1(do_mtc0_performance3, t0);
+//            gen_helper_mtc0_performance3(t0);
             rn = "Performance3";
 //            break;
         case 4:
-//            tcg_gen_helper_0_1(do_mtc0_performance4, t0);
+//            gen_helper_mtc0_performance4(t0);
             rn = "Performance4";
 //            break;
         case 5:
-//            tcg_gen_helper_0_1(do_mtc0_performance5, t0);
+//            gen_helper_mtc0_performance5(t0);
             rn = "Performance5";
 //            break;
         case 6:
-//            tcg_gen_helper_0_1(do_mtc0_performance6, t0);
+//            gen_helper_mtc0_performance6(t0);
             rn = "Performance6";
 //            break;
         case 7:
-//            tcg_gen_helper_0_1(do_mtc0_performance7, t0);
+//            gen_helper_mtc0_performance7(t0);
             rn = "Performance7";
 //            break;
         default:
@@ -5060,14 +5016,14 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
         case 2:
         case 4:
         case 6:
-            tcg_gen_helper_0_1(do_mtc0_taglo, t0);
+            gen_helper_mtc0_taglo(t0);
             rn = "TagLo";
             break;
         case 1:
         case 3:
         case 5:
         case 7:
-            tcg_gen_helper_0_1(do_mtc0_datalo, t0);
+            gen_helper_mtc0_datalo(t0);
             rn = "DataLo";
             break;
         default:
@@ -5080,14 +5036,14 @@ static void gen_dmtc0 (CPUState *env, DisasContext *ctx, TCGv t0, int reg, int s
         case 2:
         case 4:
         case 6:
-            tcg_gen_helper_0_1(do_mtc0_taghi, t0);
+            gen_helper_mtc0_taghi(t0);
             rn = "TagHi";
             break;
         case 1:
         case 3:
         case 5:
         case 7:
-            tcg_gen_helper_0_1(do_mtc0_datahi, t0);
+            gen_helper_mtc0_datahi(t0);
             rn = "DataHi";
             break;
         default:
@@ -5149,7 +5105,7 @@ static void gen_mftr(CPUState *env, DisasContext *ctx, int rt, int rd,
                      int u, int sel, int h)
 {
     int other_tc = env->CP0_VPEControl & (0xff << CP0VPECo_TargTC);
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
 
     if ((env->CP0_VPEConf0 & (1 << CP0VPEC0_MVP)) == 0 &&
         ((env->tcs[other_tc].CP0_TCBind & (0xf << CP0TCBd_CurVPE)) !=
@@ -5163,25 +5119,25 @@ static void gen_mftr(CPUState *env, DisasContext *ctx, int rt, int rd,
         case 2:
             switch (sel) {
             case 1:
-                tcg_gen_helper_1_0(do_mftc0_tcstatus, t0);
+                gen_helper_mftc0_tcstatus(t0);
                 break;
             case 2:
-                tcg_gen_helper_1_0(do_mftc0_tcbind, t0);
+                gen_helper_mftc0_tcbind(t0);
                 break;
             case 3:
-                tcg_gen_helper_1_0(do_mftc0_tcrestart, t0);
+                gen_helper_mftc0_tcrestart(t0);
                 break;
             case 4:
-                tcg_gen_helper_1_0(do_mftc0_tchalt, t0);
+                gen_helper_mftc0_tchalt(t0);
                 break;
             case 5:
-                tcg_gen_helper_1_0(do_mftc0_tccontext, t0);
+                gen_helper_mftc0_tccontext(t0);
                 break;
             case 6:
-                tcg_gen_helper_1_0(do_mftc0_tcschedule, t0);
+                gen_helper_mftc0_tcschedule(t0);
                 break;
             case 7:
-                tcg_gen_helper_1_0(do_mftc0_tcschefback, t0);
+                gen_helper_mftc0_tcschefback(t0);
                 break;
             default:
                 gen_mfc0(env, ctx, t0, rt, sel);
@@ -5191,7 +5147,7 @@ static void gen_mftr(CPUState *env, DisasContext *ctx, int rt, int rd,
         case 10:
             switch (sel) {
             case 0:
-                tcg_gen_helper_1_0(do_mftc0_entryhi, t0);
+                gen_helper_mftc0_entryhi(t0);
                 break;
             default:
                 gen_mfc0(env, ctx, t0, rt, sel);
@@ -5200,7 +5156,7 @@ static void gen_mftr(CPUState *env, DisasContext *ctx, int rt, int rd,
         case 12:
             switch (sel) {
             case 0:
-                tcg_gen_helper_1_0(do_mftc0_status, t0);
+                gen_helper_mftc0_status(t0);
                 break;
             default:
                 gen_mfc0(env, ctx, t0, rt, sel);
@@ -5209,7 +5165,7 @@ static void gen_mftr(CPUState *env, DisasContext *ctx, int rt, int rd,
         case 23:
             switch (sel) {
             case 0:
-                tcg_gen_helper_1_0(do_mftc0_debug, t0);
+                gen_helper_mftc0_debug(t0);
                 break;
             default:
                 gen_mfc0(env, ctx, t0, rt, sel);
@@ -5222,49 +5178,49 @@ static void gen_mftr(CPUState *env, DisasContext *ctx, int rt, int rd,
     } else switch (sel) {
     /* GPR registers. */
     case 0:
-        tcg_gen_helper_1_i(do_mftgpr, t0, rt);
+        gen_helper_1i(mftgpr, t0, rt);
         break;
     /* Auxiliary CPU registers */
     case 1:
         switch (rt) {
         case 0:
-            tcg_gen_helper_1_i(do_mftlo, t0, 0);
+            gen_helper_1i(mftlo, t0, 0);
             break;
         case 1:
-            tcg_gen_helper_1_i(do_mfthi, t0, 0);
+            gen_helper_1i(mfthi, t0, 0);
             break;
         case 2:
-            tcg_gen_helper_1_i(do_mftacx, t0, 0);
+            gen_helper_1i(mftacx, t0, 0);
             break;
         case 4:
-            tcg_gen_helper_1_i(do_mftlo, t0, 1);
+            gen_helper_1i(mftlo, t0, 1);
             break;
         case 5:
-            tcg_gen_helper_1_i(do_mfthi, t0, 1);
+            gen_helper_1i(mfthi, t0, 1);
             break;
         case 6:
-            tcg_gen_helper_1_i(do_mftacx, t0, 1);
+            gen_helper_1i(mftacx, t0, 1);
             break;
         case 8:
-            tcg_gen_helper_1_i(do_mftlo, t0, 2);
+            gen_helper_1i(mftlo, t0, 2);
             break;
         case 9:
-            tcg_gen_helper_1_i(do_mfthi, t0, 2);
+            gen_helper_1i(mfthi, t0, 2);
             break;
         case 10:
-            tcg_gen_helper_1_i(do_mftacx, t0, 2);
+            gen_helper_1i(mftacx, t0, 2);
             break;
         case 12:
-            tcg_gen_helper_1_i(do_mftlo, t0, 3);
+            gen_helper_1i(mftlo, t0, 3);
             break;
         case 13:
-            tcg_gen_helper_1_i(do_mfthi, t0, 3);
+            gen_helper_1i(mfthi, t0, 3);
             break;
         case 14:
-            tcg_gen_helper_1_i(do_mftacx, t0, 3);
+            gen_helper_1i(mftacx, t0, 3);
             break;
         case 16:
-            tcg_gen_helper_1_0(do_mftdsp, t0);
+            gen_helper_mftdsp(t0);
             break;
         default:
             goto die;
@@ -5274,22 +5230,22 @@ static void gen_mftr(CPUState *env, DisasContext *ctx, int rt, int rd,
     case 2:
         /* XXX: For now we support only a single FPU context. */
         if (h == 0) {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, rt);
             tcg_gen_ext_i32_tl(t0, fp0);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         } else {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32h(fp0, rt);
             tcg_gen_ext_i32_tl(t0, fp0);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         break;
     case 3:
         /* XXX: For now we support only a single FPU context. */
-        tcg_gen_helper_1_1i(do_cfc1, t0, t0, rt);
+        gen_helper_1i(cfc1, t0, rt);
         break;
     /* COP2: Not implemented. */
     case 4:
@@ -5323,7 +5279,7 @@ static void gen_mttr(CPUState *env, DisasContext *ctx, int rd, int rt,
                      int u, int sel, int h)
 {
     int other_tc = env->CP0_VPEControl & (0xff << CP0VPECo_TargTC);
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
 
     gen_load_gpr(t0, rt);
     if ((env->CP0_VPEConf0 & (1 << CP0VPEC0_MVP)) == 0 &&
